<?php
/**
 * Air Conditioning Services functions and definitions
 *
 * @subpackage Air Conditioning Services
 * @since 1.0
 */

// theme setup
function air_conditioning_services_setup() {
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'air-conditioning-services-featured-image', 2000, 1200, true );
	add_image_size( 'air-conditioning-services-thumbnail-avatar', 100, 100, true );

	load_theme_textdomain( 'air-conditioning-services', get_template_directory() . '/languages' );
	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'air-conditioning-services' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height' => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css' ) );

	if ( ! defined( 'AIR_CONDITIONING_SERVICES_SUPPORT' ) ) {
	define('AIR_CONDITIONING_SERVICES_SUPPORT',__('https://wordpress.org/support/theme/air-conditioning-services/','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_REVIEW' ) ) {
	define('AIR_CONDITIONING_SERVICES_REVIEW',__('https://wordpress.org/support/theme/air-conditioning-services/reviews/','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_LIVE_DEMO' ) ) {
	define('AIR_CONDITIONING_SERVICES_LIVE_DEMO',__('https://trial.ovationthemes.com/air-conditioning-services/','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_BUY_PRO' ) ) {
	define('AIR_CONDITIONING_SERVICES_BUY_PRO',__('https://www.ovationthemes.com/products/air-conditioning-wordpress-theme','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_PRO_DOC' ) ) {
	define('AIR_CONDITIONING_SERVICES_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-air-conditioning-services-pro-doc/','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_FREE_DOC' ) ) {
	define('AIR_CONDITIONING_SERVICES_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-air-conditioning-services-free-doc/','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_THEME_NAME' ) ) {
	define('AIR_CONDITIONING_SERVICES_THEME_NAME',__('Premium Air Conditioning Theme','air-conditioning-services'));
	}
	if ( ! defined( 'AIR_CONDITIONING_SERVICES_BUNDLE_LINK' ) ) {
	define('AIR_CONDITIONING_SERVICES_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','air-conditioning-services'));
	}
	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
	require get_template_directory() . '/inc/admin/theme-upsell.php';
}
add_action( 'after_setup_theme', 'air_conditioning_services_setup' );

//woocommerce//
//shop page no of columns
function air_conditioning_services_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'air_conditioning_services_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'air_conditioning_services_woocommerce_loop_columns' );
function air_conditioning_services_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'air_conditioning_services_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'air_conditioning_services_woocommerce_products_per_page' );
// related products
function air_conditioning_services_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'air_conditioning_services_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'air_conditioning_services_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'air_conditioning_services_related_products_args' );

// breadcrumb seperator
function air_conditioning_services_woocommerce_breadcrumb_separator($air_conditioning_services_defaults) {
    $air_conditioning_services_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $air_conditioning_services_defaults['delimiter'] = $air_conditioning_services_separator;

    return $air_conditioning_services_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'air_conditioning_services_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($air_conditioning_services_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $air_conditioning_services_classes = array_merge(['wow','zoomIn'], $air_conditioning_services_classes);
	    }
	    return $air_conditioning_services_classes;
	},10,3);
}
//woocommerce-end//

// Admin scripts and styles
function air_conditioning_services_enqueue_admin_script( $hook ) {
	wp_enqueue_style(
		'air-conditioning-services-admin-style',
		get_template_directory_uri() . '/assets/css/admin-style.css'
	);
	wp_enqueue_script(
		'air-conditioning-services-admin-js',
		get_theme_file_uri( '/assets/js/air-conditioning-services-admin.js' ),
		array( 'jquery' ),
		'1.0.0',
		true
	);
	wp_localize_script(
		'air-conditioning-services-admin-js',
		'air_conditioning_services_localize',
		array(
			'ajax_url'      => admin_url( 'admin-ajax.php' ),
			'nonce'         => wp_create_nonce( 'air_conditioning_services_dismissed_notice_nonce' ),
			'dismiss_nonce' => wp_create_nonce( 'air_conditioning_services_dismissed_notice_nonce' ),
		)
	);
}
add_action( 'admin_enqueue_scripts', 'air_conditioning_services_enqueue_admin_script' );

function air_conditioning_services_excerpt_enabled(){
	if(get_theme_mod('air_conditioning_services_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function air_conditioning_services_string_limit_words($string, $word_limit) {
$words = explode(' ', $string, ($word_limit + 1));
if(count($words) > $word_limit)
array_pop($words);
return implode(' ', $words);
}

//get-start-function-end//

// tag count
function air_conditioning_services_display_post_tag_count() {
    $air_conditioning_services_tags = get_the_tags();
    $air_conditioning_services_tag_count = ($air_conditioning_services_tags) ? count($air_conditioning_services_tags) : 0;
    $air_conditioning_services_tag_text = ($air_conditioning_services_tag_count === 1) ? 'tag' : 'tags';
    echo $air_conditioning_services_tag_count . ' ' . $air_conditioning_services_tag_text;
}

// Date formatting
function air_conditioning_services_display_shop_date() {
    // Get the date type option
    $air_conditioning_services_date_type = get_theme_mod( 'air_conditioning_services_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $air_conditioning_services_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $air_conditioning_services_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $air_conditioning_services_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $air_conditioning_services_date_to_display );
}

//media post format
function air_conditioning_services_get_media($air_conditioning_services_type = array()){
	$air_conditioning_services_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $air_conditioning_services_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $air_conditioning_services_content, $air_conditioning_services_type );
    return $output;
  }
}

//front page
function air_conditioning_services_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'air_conditioning_services_front_page_template' );

// excerpt function
function air_conditioning_services_custom_excerpt() {
    $air_conditioning_services_excerpt = get_the_excerpt();
    $air_conditioning_services_plain_text_excerpt = wp_strip_all_tags($air_conditioning_services_excerpt);
    
    // Get dynamic word limit from theme mod
    $air_conditioning_services_word_limit = esc_attr(get_theme_mod('air_conditioning_services_post_excerpt', '30'));
    
    // Limit the number of words
    $air_conditioning_services_limited_excerpt = implode(' ', array_slice(explode(' ', $air_conditioning_services_plain_text_excerpt), 0, $air_conditioning_services_word_limit));

    echo esc_html($air_conditioning_services_limited_excerpt);
}

// typography
function air_conditioning_services_fonts_scripts() {
	$headings_font = esc_html(get_theme_mod('air_conditioning_services_headings_text'));
	$body_font = esc_html(get_theme_mod('air_conditioning_services_body_text'));

	if( $headings_font ) {
		wp_enqueue_style( 'air-conditioning-services-headings-fonts', '//fonts.googleapis.com/css?family='. $headings_font );
	} else {
		wp_enqueue_style( 'air-conditioning-services-source-sans', '//fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic');
	}
	if( $body_font ) {
		wp_enqueue_style( 'air-conditioning-services-body-fonts', '//fonts.googleapis.com/css?family='. $body_font );
	} else {
		wp_enqueue_style( 'air-conditioning-services-source-body', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300,400italic,700,600');
	}
}
add_action( 'wp_enqueue_scripts', 'air_conditioning_services_fonts_scripts' );

// Footer Text
function air_conditioning_services_copyright_link() {
    $air_conditioning_services_footer_text = get_theme_mod('air_conditioning_services_footer_text', esc_html__('Air Conditioning Services WordPress Theme', 'air-conditioning-services'));
    $air_conditioning_services_credit_link = esc_url('https://www.ovationthemes.com/products/free-ac-repair-wordpress-theme');

    echo '<a href="' . $air_conditioning_services_credit_link . '" target="_blank">' . esc_html($air_conditioning_services_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'air-conditioning-services') . '</span></a>';
}

// custom sanitizations
// dropdown
function air_conditioning_services_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'air_conditioning_services_sanitize_integer' ) ) {
	function air_conditioning_services_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function air_conditioning_services_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function air_conditioning_services_sanitize_select( $input, $setting ){
    $input = sanitize_key($input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}
// toggle switch
function air_conditioning_services_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function air_conditioning_services_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}
// phone number
function air_conditioning_services_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function air_conditioning_services_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

//widgets
function air_conditioning_services_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'air-conditioning-services' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'air-conditioning-services' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'air-conditioning-services' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 1', 'air-conditioning-services' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'air-conditioning-services' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'air-conditioning-services' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'air-conditioning-services' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'air-conditioning-services' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'air_conditioning_services_widgets_init' );

//Enqueue scripts and styles.
function air_conditioning_services_scripts() {

	require_once get_theme_file_path( 'inc/wptt-webfont-loader.php' );

	wp_enqueue_style(
		'jost',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Source+Sans+3:ital,wght@0,200;0,300;0,500;0,600;0,700;0,800;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap' ),
		array(),
		'1.0'
	);

	//Bootstarp
	wp_enqueue_style( 'air-conditioning-services-bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css' );

	// Theme stylesheet.
	wp_enqueue_style( 'air-conditioning-services-style', get_stylesheet_uri() );

	// Rtl
	wp_style_add_data('air-conditioning-services-style', 'rtl', 'replace');

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'air-conditioning-services-style',$air_conditioning_services_custom_style );

	//font-awesome
	wp_enqueue_style( 'air-conditioning-services-font-awesome-style', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	//Owl Carousel CSS
	wp_enqueue_style( 'air-conditioning-services-owl.carousel-style', get_template_directory_uri().'/assets/css/owl.carousel.css' );

	// Block Style
	wp_enqueue_style( 'air-conditioning-services-block-style',get_template_directory_uri().'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'air-conditioning-services-custom.js', get_theme_file_uri( '/assets/js/theme-script.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'air-conditioning-services-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );

	//Bootstarp JS
	wp_enqueue_script( 'air-conditioning-services-bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	//Owl Carousel JS
	wp_enqueue_script( 'air-conditioning-services-owl.carousel-js', get_theme_file_uri( '/assets/js/owl.carousel.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('air_conditioning_services_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'air-conditioning-services-wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'air-conditioning-services-animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'air_conditioning_services_scripts' );

function air_conditioning_services_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'air-conditioning-services-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );
}
add_action( 'enqueue_block_editor_assets', 'air_conditioning_services_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'air_conditioning_services_customize_controls_register_scripts' );

function air_conditioning_services_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'air-conditioning-services-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

//enque files
require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typofont.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require_once get_template_directory() . '/inc/admin/welcome-notice.php';
require get_parent_theme_file_path( 'inc/sortable/sortable_control.php' );

add_action( 'admin_bar_menu', 'air_conditioning_services_add_upgrade_button', 100 );

function air_conditioning_services_add_upgrade_button( $air_conditioning_services_wp_admin_bar ) {

    $air_conditioning_services_theme_name = wp_get_theme()->get( 'Name' );

    $air_conditioning_services_args = array(
        'id'    => 'air_conditioning_services_upgrade',
        'title' => '<span style="color:#fff;font-weight:600;">
            🚀 Upgrade to ' . esc_html( $air_conditioning_services_theme_name ) . ' Pro - 20% OFF 
            <span style="background:#ff5722;color:#fff;padding:2px 8px;border-radius:3px;margin-left:6px;">
                Buy Now
            </span>
        </span>',
        'href'  => esc_url( AIR_CONDITIONING_SERVICES_BUY_PRO ),
        'meta'  => array(
            'class'  => 'air-conditioning-services-upgrade-btn',
            'title'  => 'Upgrade to Pro',
            'target' => '_blank'
        )
    );

    $air_conditioning_services_wp_admin_bar->add_node( $air_conditioning_services_args );
}